###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2005 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
%define buildup 1
%define buildsmp 1
%define buildxen 1
%define kernel_version 2.6.17-1.2187_FC5
%define subversion 2

%ifnarch i686
%define buildsmp 0
%endif 

%ifnarch i686 x86_64
%define buildxen 0
%endif

Name: gnbd-kernel
Version: 2.6.15
Release: 5.FC5.41
License: GPL
Group: System Environment/Kernel
Summary: gnbd-kernel - The kernel module for GFS's Network Block Device
BuildRequires: kernel = %{kernel_version}

%if %{buildsmp}
BuildRequires: kernel-smp = %{kernel_version}
BuildRequires: kernel-smp-devel = %{kernel_version}
%endif

%if %{buildxen}
BuildRequires: kernel-xenU = %{kernel_version}
BuildRequires: kernel-xen0 = %{kernel_version}
BuildRequires: kernel-devel = %{kernel_version}
BuildRequires: kernel-xenU-devel = %{kernel_version}
BuildRequires: kernel-xen0-devel = %{kernel_version}
%endif

Conflicts: GFS <= 6.0
Conflicts: GFS-modules
Requires: kernel = %{kernel_version}
Requires: /lib/modules/%{kernel_version}
Prereq: /sbin/depmod
Provides: gnbd-kernel-modules = %{version}-%{release}
Provides: kernel-modules
ExclusiveArch: i686 x86_64
Source0: %{name}-%{version}-%{subversion}.tar.gz
Patch0: gnbd-kernel-2.6.15-2.kernel-2.6.17.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
gnbd-kernel - The kernel module for GFS's Network Block Device

%package -n gnbd-kernheaders
Group: Development/System
Summary: gnbd kernel header files

%description -n gnbd-kernheaders
The gnbd kernel headers are used to compile the gnbd userland tools.

%if %{buildsmp}
%package -n gnbd-kernel-smp
Group: System Environment/Kernel
Summary: gnbd-kernel-smp - The kernel module for GFS's Network Block Device
Requires: kernel-smp = %{kernel_version}
Requires: /lib/modules/%{kernel_version}smp
Provides: gnbd-kernel-modules = %{version}-%{release}
Provides: kernel-modules

%description -n gnbd-kernel-smp
gnbd-kernel-smp - The smp kernel module for GFS's Network Block Device
%endif

%if %{buildxen}
%package -n gnbd-kernel-xenU
Group: System Environment/Kernel
Summary: gnbd-kernel-xenU - The kernel module for GFS's Network Block Device
Requires: kernel-xenU = %{kernel_version}
Requires: /lib/modules/%{kernel_version}xenU
Provides: gnbd-kernel-modules = %{version}-%{release}
Provides: kernel-modules

%description -n gnbd-kernel-xenU
gnbd-kernel-smp - The smp kernel module for GFS's Network Block Device

%package -n gnbd-kernel-xen0
Group: System Environment/Kernel
Summary: gnbd-kernel-xen0 - The kernel module for GFS's Network Block Device
Requires: kernel-xen0 = %{kernel_version}
Requires: /lib/modules/%{kernel_version}xen0
Provides: kernel-modules
Provides: gnbd-kernel-modules = %{version}-%{release}

%description -n gnbd-kernel-xen0
gnbd-kernel-smp - The smp kernel module for GFS's Network Block Device

%endif
################################################################################
##  THE PREP SECTION
################################################################################
%prep
%setup -q -n %{name}-%{version}-%{subversion}
%patch0 -p1 -b .kernel-2.6.17

################################################################################
##  THE BUILD SECTION
################################################################################
%build
BUILD_TOPDIR=`pwd`

cp -r `pwd` ../smp
cp -r `pwd` ../xenU
cp -r `pwd` ../xen0

Build_gnbd(){
	cpu_type=$1
	flavor=$2
	kernel_src=/lib/modules/%{kernel_version}$flavor/build
	# Kernel tree setup
	if [ -d $kernel_src/. ]; then
		echo "Kernel %{kernel_version} found."
		echo $kernel_src
	else
		echo "Kernel %{kernel_version} not found."
		echo $kernel_src
		ls /lib/modules/*
		exit 1
	fi
        ./configure --kernel_src=$kernel_src --incdir=%{_includedir}
	make %{?_smp_mflags}
}

%if %{buildup}
Build_gnbd %{_target_cpu}
%endif

%if %{buildsmp}
cd ../smp
Build_gnbd %{_target_cpu} smp
%endif

%if %{buildxen}
cd ../xenU
Build_gnbd %{_target_cpu} xenU

cd ../xen0
Build_gnbd %{_target_cpu} xen0
%endif

################################################################################
##  THE INSTALL SECTION
################################################################################
%install
rm -rf $RPM_BUILD_ROOT

%if %{buildup}
make install DESTDIR=$RPM_BUILD_ROOT
%endif

%if %{buildsmp}
cd ../smp
make install DESTDIR=$RPM_BUILD_ROOT
%endif

%if %{buildxen}
cd ../xenU
make install DESTDIR=$RPM_BUILD_ROOT
cd ../xen0
make install DESTDIR=$RPM_BUILD_ROOT
%endif


################################################################################
##  THE CLEAN SECTION
################################################################################
%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/depmod -e %{kernel_version}

%if %{buildsmp}
%post smp
/sbin/depmod -e %{kernel_version}smp
%endif

%if %{buildxen}
%post xenU
/sbin/depmod -e %{kernel_version}xenU
%post xen0
/sbin/depmod -a %{kernel_version}xen0
%endif

%files
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}/kernel/drivers/block/gnbd/gnbd.ko

%if %{buildsmp}
%files -n gnbd-kernel-smp
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}smp/kernel/drivers/block/gnbd/gnbd.ko
%endif

%if %{buildxen}
%files -n gnbd-kernel-xenU
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}xenU/kernel/drivers/block/gnbd/gnbd.ko

%files -n gnbd-kernel-xen0
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}xen0/kernel/drivers/block/gnbd/gnbd.ko
%endif

%files -n gnbd-kernheaders
%defattr(-,root,root,-)
%{_includedir}/linux/gnbd.h

%changelog
* Mon Jun 26 2006 Chris Feist <cfeist@redhat.com>
- Added patch for new kernel (2.6.17).

* Fri Mar 31 2006 Chris Feist <cfeist@redhat.com>
- Build xen for x86_64.

* Tue Mar 14 2006 Chris Feist <cfeist@Redhat.com>
- Removed 'ARCH=xen' for xen builds.

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 2.6.15.0-20051108.134753.FC5.18.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Fri Jan 13 2006 Chris Feist <cfeist@redhat.com>
- Rebuilt, bumped version number to 2.6.15 and added xen build.

* Wed Jan 11 2006 Jesse Keating <jkeating@redhat.com>
- rebuilt again

* Tue Jan 10 2006 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Fri Dec 30 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Wed Dec 28 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Tue Dec 27 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Fri Dec 20 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Mon May 23 2005 Chris Feist <cfeist@redhat.com>
- Fixed depmod in %post scriptlet to use correct kernel.

* Tue May 17 2005 Chris Feist <cfeist@redhat.com>
- Provides gnbd-kernel-modules & added ARCH=xen to build.

* Mon May 16 2005 Chris Feist <cfeist@redhat.com>
- Add depmod in %post scriplet.

* Fri May 06 2005 Chris Feist <cfeist@redhat.com>
- Cleanup .spec file.  Don't include file globs anymore.

* Fri Apr 29 2005 Chris Feist <cfeist@redhat.com>
- Rebuild for new kernel
- Adding support for i586, xen0 & xenU

* Mon Dec 20 2004 Chris Feist <cfeist@redhat.com>
- Rebuild for new kernel.

* Fri Dec 10 2004 Chris Feist <cfeist@redhat.com>
- Rebuild for new kernel.

* Thu Nov 18 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Mon Oct 25 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Tue Aug 17 2004 Jon Brassow <jbrassow@redhat.com>
- various bug fixes (new upstream sources)
- building smp modules, but not packaging them (fixed)

* Thu Jun 17 2004 Jon Brassow <jbrassow@redhat.com> 
- Initial build.
